您的位置:首页 > 其它

UVA 题目11258 - String Partition(DP)

2015-12-03 22:20 441 查看
John was absurdly busy for preparing a programming contest recently. He wanted to create a ridiculously

easy problem for the contest. His problem was not only easy, but also boring: Given a list of

non-negative integers, what is the sum of them?

However, he made a very typical mistake when he wrote a program to generate the input data for

his problem. He forgot to print out spaces to separate the list of integers. John quickly realized his

mistake after looking at the generated input file because each line is simply a string of digits instead of

a list of integers.

He then got a better idea to make his problem a little more interesting: There are many ways to

split a string of digits into a list of non-zero-leading (0 itself is allowed) 32-bit signed integers. What is

the maximum sum of the resultant integers if the string is split appropriately?

Input

The input begins with an integer N (≤ 500) which indicates the number of test cases followed. Each

of the following test cases consists of a string of at most 200 digits.

Output

For each input, print out required answer in a single line.

Sample Input

6

1234554321

5432112345

000

121212121212

2147483648

11111111111111111111111111111111111111111111111111111

Sample Output

1234554321

543211239

0

2121212124

214748372

5555555666

题目大意:一个字符串切成若干串,每个串一个整数,问切割获得的最大和

ac代码

#include<stdlib.h>
#include<string.h>
#include<iostream>
#include<algorithm>
#include<stdio.h>
#include<math.h>
#include<limits.h>
#define LL long long
using namespace std;
char str[220];
LL dp[220];
int n;
void solve()
{
int i,j,k;
memset(dp,0,sizeof(dp));
for(i=1;i<=n;i++)
{
for(j=1;j<=i&&j<=10;j++)
{
LL sum=0;
for(k=1;k<=j;k++)
{
sum=sum*10+(str[i-j+k]-'0');
}
if(sum<=INT_MAX)
dp[i]=max(dp[i],dp[i-j]+sum);
}
}
}
int main()
{
int t;
scanf("%d",&t);
while(t--)
{
scanf("%s",str+1);
n=strlen(str+1);
solve();
printf("%lld\n",dp
);
}
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: